// Generated by CoffeeScript 1.12.7

/*
This program is distributed under the terms of the GPLv3 license.
Copyright (c) 2015 - 2017 Markus Kohlhase <mail@markus-kohlhase.de>
 */

(function() {
  var ANGLE, COLORS, Leaf, PureMixin, React, T, g, path, rad, ref;

  React = require("react");

  Leaf = require("./leaf");

  PureMixin = require("react-pure-render/mixin");

  ref = React.DOM, g = ref.g, path = ref.path;

  COLORS = ['#96bf0c', '#ffdd00', '#e56091', '#aa386b', '#637a84', '#0099ad'];

  ANGLE = 60;

  rad = function(deg) {
    return deg * Math.PI / 180;
  };

  T = React.PropTypes;

  module.exports = React.createClass({
    displayName: "Flower",
    mixins: [PureMixin],
    propTypes: {
      scales: T.arrayOf(T.number),
      colors: T.arrayOf(T.string),
      size: T.number,
      space: T.number
    },
    getDefaultProps: function() {
      return {
        scales: [1, 1, 1, 1, 1, 1],
        size: 100
      };
    },
    statics: {
      Leaf: Leaf
    },
    getTransformation: function(i, space) {
      var deg, s;
      deg = i * ANGLE;
      s = this.props.scales[i];
      if (s == null) {
        s = 1;
      }
      return "translate(" + (space * Math.cos(rad(deg))) + "," + (space * Math.sin(rad(deg))) + ") rotate(" + (deg - 90) + ") scale(" + s + ")";
    },
    getSpace: function() {
      var s;
      if ((s = this.props.space) != null) {
        return s;
      } else {
        return this.props.size * 0.03;
      }
    },
    render: function() {
      var h, i, leafs, s, space, w;
      space = this.getSpace();
      s = this.props.scales;
      h = (this.props.size / 2) - space;
      w = 0.7 * h;
      leafs = (function() {
        var j, ref1, results;
        results = [];
        for (i = j = 0; j <= 5; i = ++j) {
          results.push(React.createElement(Leaf, {
            key: i,
            transform: this.getTransformation(i, space),
            color: ((ref1 = this.props.colors) != null ? ref1[i] : void 0) || COLORS[i],
            height: h,
            width: w
          }));
        }
        return results;
      }).call(this);
      return g({
        transform: this.props.transform
      }, leafs);
    }
  });

}).call(this);
